Index: pplinux/linuxnew/drivers/i2c/i2c-slave.c
diff -u /dev/null pplinux/linuxnew/drivers/i2c/i2c-slave.c:1.1
--- /dev/null	Tue May 24 10:37:59 2005
+++ pplinux/linuxnew/drivers/i2c/i2c-slave.c	Thu Feb  3 11:35:37 2005
@@ -0,0 +1,381 @@
+#include <linux/version.h>
+#include <linux/kernel.h>
+#include <linux/module.h>
+#include <linux/i2c.h>
+#include <linux/i2c-slave.h>
+#include <linux/init.h>
+#include <linux/errno.h>
+#include <linux/config.h>
+#include <asm/io.h>
+
+/* ------------------------------------------------------------------------- *
+ * Module debugging and output stuff
+ * ------------------------------------------------------------------------- */
+
+#define DBG_LEVEL 1
+
+#if DBG_LEVEL > 0
+#  define DBG(fmt, x...)	printk(KERN_DEBUG "i2c-slave: " fmt, ##x)
+#else
+#  define DBG(fmt, x...)	((void)0)
+#endif
+#if DBG_LEVEL > 1
+#  define DBG2(fmt, x...) 	DBG( fmt, ##x )
+#else
+#  define DBG2(fmt, x...) 	((void)0)
+#endif
+#if DBG_LEVEL > 2
+static void
+dump_iic_buf(const char* string, const char* buf, int len)
+{
+	int i;
+	printk(KERN_DEBUG"%s: Bytes:\n", string);
+	for (i = 0; i < len; i++) {
+		printk(KERN_DEBUG"0x%02x ", buf[i] & 0xff);
+	}
+	printk(KERN_DEBUG"\n");
+}
+#  define DUMP_BUF(s, buf,len)	dump_iic_buf((s),(buf),(len))
+#else
+#  define DUMP_BUF(s, buf,len)	((void)0)
+#endif
+
+#define WARN(fmt, x...)		printk(KERN_WARNING "i2c-slave: " fmt, ##x)
+
+/* ------------------------------------------------------------------------- *
+ * Global constants and variables
+ * ------------------------------------------------------------------------- */
+
+/* the max. number of I2C adapters and logical devices */
+#define MAX_NO_ADAPTERS	16
+#define MAX_NO_DEVICES	16
+
+/* the I2C adapters list */
+static struct i2c_slave_adapter* adapters[MAX_NO_DEVICES];
+
+/* the I2C devices list */
+static struct i2c_slave_device* devices[MAX_NO_DEVICES];
+
+/* spinlocks for access to the adapters and devices list */
+static spinlock_t adapters_lock = SPIN_LOCK_UNLOCKED;
+static spinlock_t devices_lock = SPIN_LOCK_UNLOCKED;
+
+/* ------------------------------------------------------------------------- *
+ * Initailization stuff
+ * ------------------------------------------------------------------------- */
+
+static __init int
+i2c_slave_init(void)
+{
+	unsigned long flags;
+	
+	DBG("module init.\n");
+	
+	/* initialize the adapter and device lists */
+	spin_lock_irqsave(&adapters_lock, flags);
+	memset(adapters, 0, sizeof(adapters));
+	spin_unlock_irqrestore(&adapters_lock, flags);
+	
+	spin_lock_irqsave(&devices_lock, flags);
+	memset(devices, 0, sizeof(adapters));
+	spin_unlock_irqrestore(&devices_lock, flags);
+	
+	DBG("module initialization finished.\n");
+	return 0;
+}
+
+static __exit void
+i2c_slave_cleanup(void)
+{
+	DBG("module cleanup.\n");
+	
+	/* nothing to do at the moment */
+	
+	DBG("module cleanup finished.\n");
+}
+
+/* ------------------------------------------------------------------------- *
+ * Adapter and Device managing functions
+ * ------------------------------------------------------------------------- */
+
+int
+i2c_slave_add_adapter(struct i2c_slave_adapter* adapter)
+{
+	unsigned long flags;
+	int i, ret = 0;
+
+	spin_lock_irqsave(&adapters_lock, flags);
+
+	for (i = 0; i < MAX_NO_ADAPTERS; i++)
+		if (adapters[i] == NULL)
+			break;
+	
+	if (i == MAX_NO_ADAPTERS) {
+		WARN("i2c_slave_add_adapter(%s) - enlarge MAX_NO_ADAPTERS.\n",
+			adapter->adapter->name);
+		ret = -ENOMEM;
+		goto bail;
+	}
+
+	adapters[i] = adapter;
+	
+	DBG("added adapter %s\n", adapter->adapter->name);
+
+bail:
+	spin_unlock_irqrestore(&adapters_lock, flags);
+	return ret;
+}
+
+int
+i2c_slave_remove_adapter(struct i2c_slave_adapter* adapter)
+{
+	unsigned long flags;
+	int i, ret = 0;
+
+	spin_lock_irqsave(&adapters_lock, flags);
+
+	for (i = 0; i < I2C_ADAP_MAX; i++)
+		if (adapters[i] == adapter)
+			break;
+	
+	if (MAX_NO_ADAPTERS == i) {
+		WARN("i2c_slave_remove_adapter adapter [%s] not found.\n",
+			adapter->adapter->name);
+		ret = -ENODEV;
+		goto bail;
+	}
+	
+	adapters[i] = NULL;
+
+	DBG("removed adapter %s\n", adapter->adapter->name);
+
+bail:
+	spin_unlock_irqrestore(&adapters_lock, flags);
+	return ret;
+}
+
+int
+i2c_slave_add_device(struct i2c_slave_device* device)
+{
+	unsigned long flags;
+	int i, ret = 0;
+
+	spin_lock_irqsave(&devices_lock, flags);
+
+	for (i = 0; i < MAX_NO_DEVICES; i++)
+		if (devices[i] == NULL)
+			break;
+	
+	if (i == MAX_NO_DEVICES) {
+		WARN("i2c-slave.o: i2c_slave_add_device(%s) - enlarge MAX_NO_DEVICES.\n",
+			device->name);
+		ret = -ENOMEM;
+		goto bail;
+	}
+
+	devices[i] = device;
+
+	DBG("added device %s\n", device->name);
+
+bail:
+	spin_unlock_irqrestore(&devices_lock, flags);
+	return ret;
+}
+
+int
+i2c_slave_remove_device(struct i2c_slave_device* device)
+{
+	unsigned long flags;
+	int i, ret = 0;
+
+	spin_lock_irqsave(&devices_lock, flags);
+
+	for (i = 0; i < I2C_ADAP_MAX; i++)
+		if (devices[i] == device)
+			break;
+	
+	if (MAX_NO_DEVICES == i) {
+		WARN("i2c_slave_remove_device device [%s] not found.\n",
+			device->name);
+		ret = -ENODEV;
+		goto bail;
+	}
+	
+	devices[i] = NULL;
+
+	DBG("removed device %s\n", device->name);
+
+bail:
+	spin_unlock_irqrestore(&devices_lock, flags);
+	return ret;
+}
+
+/* ------------------------------------------------------------------------- *
+ * Unblock functions
+ * ------------------------------------------------------------------------- */
+
+void
+unblock_adapter(struct i2c_adapter* adapter)
+{
+	struct i2c_slave_adapter* adap = NULL;
+	int i;
+	unsigned long flags;
+	
+	/* search the correct adapter */
+	spin_lock_irqsave(&adapters_lock, flags);
+
+	for (i = 0; i < I2C_ADAP_MAX; i++) {
+		if (adapters[i]->adapter == adapter) {
+			adap = adapters[i];
+			break;
+		}
+	}
+	
+	if (adap != NULL) {
+		DBG2("Unblock apapter %s.\n", adapter->name);
+		adap->reactivate(adapter);
+	}
+	else {
+		WARN("%s: No adapter to unblock!\n", adapter->name);
+	}
+	
+	spin_unlock_irqrestore(&adapters_lock, flags);
+}
+
+/* ------------------------------------------------------------------------- *
+ * Read and write functions
+ * ------------------------------------------------------------------------- */
+
+static struct i2c_slave_device* responsible_device = NULL;
+
+static void
+iic_slave_search_responsible_device(struct i2c_adapter* adapter, char* buf, int len)
+{
+	int i;
+	
+	responsible_device = NULL;
+	
+	for (i = 0; i < MAX_NO_DEVICES; i++) {
+		if (!devices[i]) continue;
+		
+		DBG2("Probing device %s\n", devices[i]->name);
+		if (devices[i]->adapter &&
+		    devices[i]->adapter == adapter &&
+		    devices[i]->is_responsible &&
+		    devices[i]->is_responsible(buf, len)) {
+			responsible_device = devices[i];
+			DBG2("Device %s responsible.\n", devices[i]->name);
+			break;
+		}
+#if DBG_LEVEL > 2
+		else if (devices[i]->adapter != adapter) {
+			DBG2("Device %s not responsible, adapters do not match.\n", devices[i]->name);
+		}
+		else {
+			DBG2("Device %s not responsible, refused data.\n", devices[i]->name);
+		}
+#endif
+	}
+}
+
+int
+iic_slave_write(struct i2c_adapter* adapter, char* buf, int len)
+{
+	int ret = 0;
+	unsigned long flags;
+	
+	DBG2("iic_slave_write: writing %d bytes.\n", len);
+
+	spin_lock_irqsave(&devices_lock, flags);
+	
+	/* find the device responsible for the current data transfer */
+	iic_slave_search_responsible_device(adapter, buf, len);
+	
+	if (responsible_device && responsible_device->slave_write) {
+		ret = responsible_device->slave_write(buf, len);
+		if (ret < 0) {
+			DBG("iic_slave_write: error writing bytes.\n");
+		}
+		else {
+			DBG2("iic_slave_write: %d bytes written.\n", len);
+		}
+	}
+	else {
+		WARN("iic_slave_write: no responsible device, discarding data!\n");
+		DUMP_BUF("iic_slave_write", buf, len);
+		
+		/* we fake the return value for the driver,
+		   it must not assume that an error occured */
+		ret = len;
+	}
+			
+	spin_unlock_irqrestore(&devices_lock, flags);
+	
+	return ret;
+}
+
+int
+iic_slave_read(struct i2c_adapter* adapter, char* buf, int len, int command)
+{
+	int i = 0;
+	int ret = 0;
+	static int start = 0;
+	
+	DBG2("iic_slave_read: %d reading bytes.\n", len);
+	
+	/* find the device responsible for the current data transfer */
+	if (command >= 0) {
+		unsigned char dev_buf = command & 0xff;
+		iic_slave_search_responsible_device(adapter, &dev_buf, 1);
+	}
+	
+	if (responsible_device && responsible_device->slave_read) {
+		ret = responsible_device->slave_read(buf, len);
+		if (ret < 0) {
+			DBG("iic_slave_read: error reading bytes.\n");
+		}
+		else {
+			DBG2("iic_slave_read: %d bytes read.\n", len);
+		}
+	}
+	else {
+		WARN("iic_slave_read: no responsible device!\n");
+		
+		ret = len;
+		
+		/* write dummy bytes */
+		for (i = 0; i < len; i++) {
+			buf[i] = i + start;
+		}
+		
+		DUMP_BUF("iic_slave_read", buf, len);
+			
+		start++;
+	}
+
+	return ret;
+}
+
+/* ------------------------------------------------------------------------- *
+ * Linux kernel module stuff
+ * ------------------------------------------------------------------------- */
+
+#ifdef MODULE
+
+MODULE_AUTHOR("thre@peppercon.de");
+MODULE_DESCRIPTION("Linux kernel module for I2C slave operations");
+
+module_init(i2c_slave_init);
+module_exit(i2c_slave_cleanup);
+
+#endif	/* MODULE */
+
+EXPORT_SYMBOL(i2c_slave_add_adapter);
+EXPORT_SYMBOL(i2c_slave_remove_adapter);
+EXPORT_SYMBOL(i2c_slave_add_device);
+EXPORT_SYMBOL(i2c_slave_remove_device);
+
+EXPORT_SYMBOL(iic_slave_write);
+EXPORT_SYMBOL(iic_slave_read);
+
+EXPORT_SYMBOL(unblock_adapter);
Index: pplinux/linuxnew/drivers/isdn/isdn_common.c
diff -u pplinux/linuxnew/drivers/isdn/isdn_common.c:1.1.323.1 pplinux/linuxnew/drivers/isdn/isdn_common.c:1.2
--- pplinux/linuxnew/drivers/isdn/isdn_common.c:1.1.323.1	Thu Feb  3 10:00:49 2005
+++ pplinux/linuxnew/drivers/isdn/isdn_common.c	Thu Feb  3 11:35:37 2005
@@ -485,6 +485,10 @@
 				isdn_command(&cmd);
 				return 0;
 			}
+			if (c->arg >= 0 && c->arg < ISDN_MAX_CHANNELS) {
+				memcpy(dev->last_caller[c->arg], c->parm.setup.phone, ISDN_MSNLEN);
+				memcpy(dev->last_called[c->arg], c->parm.setup.eazmsn, ISDN_MSNLEN);
+			}
 			/* Try to find a network-interface which will accept incoming call */
 			r = ((c->command == ISDN_STAT_ICALLW) ? 0 : isdn_net_find_icall(di, c->arg, i, &c->parm.setup));
 			switch (r) {
@@ -1575,6 +1579,22 @@
 					return 0;
 				} else
 					return -EINVAL;
+			case IIOCLASTCALLER:
+				if (arg) {
+					if (copy_to_user((char *) arg, dev->last_caller, sizeof(dev->last_caller)))
+						return -EFAULT;
+					return 0;
+				} else
+					return -EINVAL;
+				break;
+			case IIOCLASTCALLED:
+				if (arg) {
+					if (copy_to_user((char *) arg, dev->last_called, sizeof(dev->last_called)))
+						return -EFAULT;
+					return 0;
+				} else
+					return -EINVAL;
+				break;
 			case IIOCDBGVAR:
 				if (arg) {
 					if (copy_to_user((char *) arg, (char *) &dev, sizeof(ulong)))
Index: pplinux/linuxnew/drivers/isdn/hisax/config.c
diff -u pplinux/linuxnew/drivers/isdn/hisax/config.c:1.1.323.1 pplinux/linuxnew/drivers/isdn/hisax/config.c:1.2
--- pplinux/linuxnew/drivers/isdn/hisax/config.c:1.1.323.1	Thu Feb  3 10:00:49 2005
+++ pplinux/linuxnew/drivers/isdn/hisax/config.c	Thu Feb  3 11:35:38 2005
@@ -864,7 +864,7 @@
 	irq_cnt = kstat_irqs(cs->irq);
 	printk(KERN_INFO "%s: IRQ %d count %d\n", CardType[cs->typ],
 	       cs->irq, irq_cnt);
-	if (request_irq(cs->irq, cs->irq_func, cs->irq_flags, "HiSax", cs)) {
+	if (request_irq(cs->irq, cs->irq_func, cs->irq_flags|SA_SAMPLE_RANDOM, "HiSax", cs)) {
 		printk(KERN_WARNING "HiSax: couldn't get interrupt %d\n",
 		       cs->irq);
 		restore_flags(flags);
